
/*
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef Clock_DS1307_h
#define Clock_DS1307_h
#include <inttypes.h>
#include "WProgram.h"


#define DS1307_ADDRESS 0x68

#define CLOCK_MAX_DAY_SECONDS 86400

// Reads the current hour from the clock
void getTime(byte *hours, byte *minutes, byte *seconds); 
// Reads the current date from the clock
void getDate(byte *day, byte *month, byte *year); 
// Returns the number of seconds since the beginning of the current day
long getDaySeconds(); 
// Sets the date and time on the clock
void setClock(byte hours, byte minutes, byte seconds, byte day, byte month, byte year, byte week_day);

long timeToSeconds(byte *hours, byte *minutes, byte *seconds);
void secondsToTime(long *long_seconds, byte *hours, byte *minutes, byte *seconds);
void timeString(char *buff);
void timeString(char *buff, long *long_seconds);
void timeString(char *buff, byte *hours, byte *minutes, byte *seconds);

void getTimeFromString(char *buff, byte *hours, byte *minutes, byte *seconds); 

byte bcdToDec(byte val);
byte decToBcd(byte val);

#endif
