
#include "WProgram.h"
#include "ShiftRegister.h"


ShiftRegister::ShiftRegister( uint8_t SER_pin , uint8_t RCLK_pin , uint8_t SRCLK_pin , uint8_t number_of_outputs )
{
	this->SER_pin = SER_pin;
	this->RCLK_pin = RCLK_pin;
	this->SRCLK_pin = SRCLK_pin;
	this->number_of_outputs = number_of_outputs;
	registers = (byte*)(malloc(number_of_outputs*sizeof(byte)));
	pinMode(this->SER_pin, OUTPUT);
	pinMode(this->RCLK_pin, OUTPUT);
	pinMode(this->SRCLK_pin, OUTPUT);

}

void ShiftRegister::initRegisters(uint8_t value)
{
	for(int i = 0; i<number_of_outputs ; i++)
	{
		registers[i] = value;
	}
}

void ShiftRegister::setRegister( uint8_t pin_number, uint8_t value)
{
	registers[pin_number] = value;
}

void ShiftRegister::writeRegisters()
{
	digitalWrite(RCLK_pin, LOW);
	for(int i = number_of_outputs - 1; i >=  0; i--)
	{
		digitalWrite(SRCLK_pin, LOW);
		int val = registers[i];
		digitalWrite(SER_pin, val);
		digitalWrite(SRCLK_pin, HIGH);
	}
	digitalWrite(RCLK_pin, HIGH);
}
/*
void ShiftRegister::writeRegistersDebug()
{
	Serial.println("Writting:");
	digitalWrite(RCLK_pin, LOW);
	for(int i = number_of_outputs - 1; i >=  0; i--)
	{
		digitalWrite(SRCLK_pin, LOW);
		Serial.print("pos:");
		Serial.println(i);

		int val = registers[i];
		delay(250);
		digitalWrite(SER_pin, val);
		delay(250);
		digitalWrite(SRCLK_pin, HIGH);
		delay(250);
	}
	digitalWrite(RCLK_pin, HIGH);
	Serial.println("Finished Writting");
}
*/

void ShiftRegister::setRegisterNow( uint8_t pin_number, uint8_t value)
{
	int current_value = registers[pin_number];
	if (value != current_value)
	{
		registers[pin_number] = value;
		writeRegisters();
	}
}

